#!/bin/sh

PREFIX=/home/jeff/work/m68k/usr

echo building for --prefix=$PREFIX
mkdir $PREFIX

echo sources

mkdir src
cd src

tar -jxvf ../archive/binutils-2.16.1.tar.bz2
tar -jxvf ../archive/gcc-4.2.4.tar.bz2

echo patching

patch -p0 << EOF
diff -urN gcc-4.2.4.orig/gcc/toplev.c gcc-4.2.4/gcc/toplev.c
--- gcc-4.2.4.orig/gcc/toplev.c	2007-09-02 00:28:30.000000000 +0900
+++ gcc-4.2.4/gcc/toplev.c	2022-12-06 12:37:27.152975079 +0900
@@ -530,7 +530,8 @@
    for floor_log2 and exact_log2; see toplev.h.  That construct, however,
    conflicts with the ISO C++ One Definition Rule.   */

-#if GCC_VERSION < 3004 || !defined (__cplusplus)
+#if 1
+//GCC_VERSION < 3004 || !defined (__cplusplus)

 /* Given X, an unsigned number, return the largest int Y such that 2**Y <= X.
    If X is 0, return -1.  */
diff -urN gcc-4.2.4.orig/gcc/toplev.h gcc-4.2.4/gcc/toplev.h
--- gcc-4.2.4.orig/gcc/toplev.h	2007-09-02 00:28:30.000000000 +0900
+++ gcc-4.2.4/gcc/toplev.h	2022-12-06 12:38:08.788974837 +0900
@@ -168,7 +168,7 @@
 #  define CLZ_HWI __builtin_clz
 #  define CTZ_HWI __builtin_ctz
 # endif
-
+#if 0
 extern inline int
 floor_log2 (unsigned HOST_WIDE_INT x)
 {
@@ -180,6 +180,7 @@
 {
   return x == (x & -x) && x ? (int) CTZ_HWI (x) : -1;
 }
+#endif
 #endif /* GCC_VERSION >= 3004 */

 /* Functions used to get and set GCC's notion of in what directory
EOF

echo build binutils

mkdir ../build
mkdir ../build/binutils
cd    ../build/binutils

../../src/binutils-2.16.1/configure --prefix=$PREFIX --target=m68k-aout

make -j8
make install

echo build gcc

mkdir ../gcc
cd    ../gcc

../../src/gcc-4.2.4/configure --prefix=$PREFIX --target=m68k-aout
make LANGUAGES=c all-gcc -j8
make LANGUAGES=c install-gcc

